import threading
from utils.s7data import S7data
from models.data_sender import Sender

class Parking:
    def __init__(self, data_s7: S7data, sender: Sender):
        self.sender = sender

        self.ccmNo_list = ["5", "6", "6", "6"]

        self.auto_trigger = []
        self.manual_trigger = []
        self.value_a = []
        self.value_m = []

        self.lock = threading.Lock()
        self.current_car = ["", "", "", ""]

        self.plate_set = {'厂内00664', '厂内00415', '厂内00687', '厂内00701', '厂内00700', '厂内00901', '厂内00699', '厂内00695', '厂内00694', '厂内00693', '厂内00692', '厂内00902', '厂内00690', '厂内00689', '陕E08582D', '陕E08515D', '陕E08000D', '陕E00298D'}

        for name in range(4):
            tmp = data_s7.make_point(f"车{name+1}自动触发信号")
            tmp.set_excite_action(lambda i=name: self.signal_on(i, 0))
            self.auto_trigger.append(tmp)

            tmp = data_s7.make_point(f"车{name+1}手动触发信号")
            tmp.set_excite_action(lambda i=name: self.signal_on(i, 1))
            self.manual_trigger.append(tmp)

            self.value_a.append(data_s7.make_point(f"车{name+1}自动触发结果"))
            self.value_m.append(data_s7.make_point(f"车{name+1}手动触发结果"))


    def signal_on(self, i, manual_flag):
        if manual_flag:
            valuedata = self.value_m[i]
        else:
            valuedata = self.value_a[i]

        with self.lock:
            if self.current_car[i] != valuedata.data:
                self.current_car[i] = valuedata.data
                self.sender.car_add(self.ccmNo_list[i], str(i+1), self.current_car[i])
            